/*----------------------------------------------------------------*/
/*								  */
/*  Example of sqldro(), sqldrr() and sqldrc() :		  */
/*		Directory Open, Read and Close			  */
/*								  */
/*----------------------------------------------------------------*/

#include "stdio.h"
#include "sql.h"
#include "errsql.h"
#include "sqlsrv.h"

/* error defines */
#define APIERROR    1

#define apierr(a) error(a,__LINE__, APIERROR)
  
	  SQLTRCD rcd;				/* return code		  */
	
	  
	  main()
{
	  SQLTSVH shandle;
          SQLTDAP srvname;
	  char    *password;
	  char    *dirname;
	  int	  modulo;
	  char    buffer[3000];
   	  
   srvname = "SERVER1";
   password = 0;
   dirname="\\SQLBASE";
   
  /* CONNECT TO THE SERVER  */

  if (rcd = sqlcsv(&shandle,srvname,password))
    apierr("SQLCSV");
  else
    printf("Connection Established to Server \n");
  
  /* directory open, read and close */
  printf("Directory open, read, close \n");

  printf("\nOpen a directory of %s\n", dirname);
  if ((rcd = sqldro(shandle, dirname)) != 0)
    apierr("SQLDRO");
  else  
    {
      printf("Directory opened successfully, rcd=%d\n",rcd);
      modulo = 0;
      while ((rcd = sqldrr(shandle, buffer)) == 0)
      {
        if ((modulo++ % 3) == 0)
	  printf("\n");
	  printf("%-13s", buffer);
      }
	printf("\n");
	printf("sqldrr() = %u\n", rcd);
	if (rcd = sqldrc(shandle))
	  apierr("SQLDRC");
	else
	  printf("Directory closed successfully, rcd= %d\n",rcd);
	
    }
    
  printf("End of directory open, read, and close\n");
    
  	  
  /* DISCONNECT FROM THE SERVER */

  if (rcd = sqldsv(shandle))
    apierr("SQLDSV");
  else
    printf("Disconnected from Server \n");
}


/*
  ERROR - prints an error message for the utility
*/
	  error(what, line, type)
	  char*     what;		/* description of what happened     */
	  int	    line;		/* line number where error occured  */
	  int	    type;		/* type of error		    */
  {
	  char	    msg[200];		/* error message buffer 	    */

      sqlerr(rcd, msg); 		  /* get the error message	    */
      printf("\nError: %s at line %d: %s, Error # %d\n", what, line, msg,rcd);
  }


